package org.gcube.portlets.user.workspace.client.event;

import org.gcube.portlets.user.workspace.client.interfaces.EventsTypeEnum;
import org.gcube.portlets.user.workspace.client.interfaces.GuiEventInterface;
import org.gcube.portlets.user.workspace.client.model.FileModel;
import org.gcube.portlets.user.workspace.shared.WorkspaceTrashOperation;

import com.google.gwt.event.shared.GwtEvent;

/**
 * 
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 * @May 23, 2013
 * 
 */
public class TrashEvent extends GwtEvent<TrashEventHandler> implements GuiEventInterface{
	
	public static Type<TrashEventHandler> TYPE = new Type<TrashEventHandler>();
	
	private FileModel targetFileModel;
	private WorkspaceTrashOperation trashOperation;

	public TrashEvent(WorkspaceTrashOperation trashOperation, FileModel target) {
		this.trashOperation = trashOperation;
		this.setTargetFileModel(target);
	}

	@Override
	public Type<TrashEventHandler> getAssociatedType() {
		return TYPE;
	}

	@Override
	protected void dispatch(TrashEventHandler handler) {
		handler.onTrashEvent(this);
	}

	/**
	 * @return the targetFileModel
	 */
	public FileModel getTargetFileModel() {
		return targetFileModel;
	}

	/**
	 * @param targetFileModel the targetFileModel to set
	 */
	public void setTargetFileModel(FileModel targetFileModel) {
		this.targetFileModel = targetFileModel;
	}

	public WorkspaceTrashOperation getTrashOperation() {
		return trashOperation;
	}

	/* (non-Javadoc)
	 * @see org.gcube.portlets.user.workspace.client.interfaces.GuiEventInterface#getKey()
	 */
	@Override
	public EventsTypeEnum getKey() {
		return EventsTypeEnum.TRASH_EVENT;
	}

	public void setTrashOperation(WorkspaceTrashOperation trashOperation) {
		this.trashOperation = trashOperation;
	}
	

}
