package org.gcube.portlets.user.workspace.client.model;

import java.util.Date;

/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class FileTrashedModel extends FileGridModel {

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2186023125020221821L;

	private String orginalPath;
	private Date deleteDate;
	private InfoContactModel deleteUser;

	public static enum STOREINFO {ORIGINALPATH, DELETEDATE, DELETEUSER}
	
	
	public FileTrashedModel() {
	}
	
	
	/**
	 * 
	 * @param identifier
	 * @param name
	 * @param path
	 * @param creationDate
	 * @param parent
	 * @param size
	 * @param isDirectory
	 * @param isShared
	 */
	public FileTrashedModel(String identifier, String name, String path, Date creationDate, FileModel parent, long size, boolean isDirectory, boolean isShared) {
		super(identifier, name, path, creationDate, parent, size, isDirectory, isShared);
	}
	
	
	/**
	 * @param orginalPath
	 * @param deleteDate
	 * @param deleteUser
	 */
	public FileTrashedModel(String orginalPath, Date deleteDate,
			InfoContactModel deleteUser) {
		super();
		this.orginalPath = orginalPath;
		this.deleteDate = deleteDate;
		this.deleteUser = deleteUser;
	}


	/**
	 * 
	 * @param identifier
	 * @param name
	 * @param creationDate
	 * @param parent
	 * @param size
	 * @param isDirectory
	 * @param isShared
	 */
	public FileTrashedModel(String identifier, String name, Date creationDate, FileModel parent, long size, boolean isDirectory, boolean isShared) {
		super(identifier, name, creationDate, parent, size, isDirectory, isShared);
	}



	public String getOrginalPath() {
		return orginalPath;
	}



	public Date getDeleteDate() {
		return deleteDate;
	}



	public InfoContactModel getDeleteUser() {
		return deleteUser;
	}



	public void setOrginalPath(String orginalPath) {
		set(STOREINFO.ORIGINALPATH.toString(), orginalPath);
		this.orginalPath = orginalPath;
	}



	public void setDeleteDate(Date deleteDate) {
		set(STOREINFO.DELETEDATE.toString(), deleteDate);
		this.deleteDate = deleteDate;
	}



	public void setDeleteUser(InfoContactModel deleteUser) {
		set(STOREINFO.DELETEUSER.toString(), deleteUser);
		this.deleteUser = deleteUser;
	}



	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("FileTrashedModel [orginalPath=");
		builder.append(orginalPath);
		builder.append(", deleteDate=");
		builder.append(deleteDate);
		builder.append(", deleteUser=");
		builder.append(deleteUser);
		builder.append(", getSize()=");
		builder.append(getSize());
		builder.append(", getLastModification()=");
		builder.append(getLastModification());
		builder.append(", getDescription()=");
		builder.append(getDescription());
		builder.append(", isShareable()=");
		builder.append(isShareable());
		builder.append(", isMarkAsRead()=");
		builder.append(isMarkAsRead());
		builder.append(", getOwner()=");
		builder.append(getOwner());
		builder.append(", getOwnerFullName()=");
		builder.append(getOwnerFullName());
		builder.append(", getListUserSharing()=");
		builder.append(getListUserSharing());
		builder.append(", isShared()=");
		builder.append(isShared());
		builder.append(", isRoot()=");
		builder.append(isRoot());
		builder.append(", getIcon()=");
		builder.append(getIcon());
		builder.append(", getAbstractPrototypeIcon()=");
		builder.append(getAbstractPrototypeIcon());
		builder.append(", getStatus()=");
		builder.append(getStatus());
		builder.append(", getIdentifier()=");
		builder.append(getIdentifier());
		builder.append(", getShortcutCategory()=");
		builder.append(getShortcutCategory());
		builder.append(", getName()=");
		builder.append(getName());
		builder.append(", getParentFileModel()=");
		builder.append(getParentFileModel());
		builder.append(", isDirectory()=");
		builder.append(isDirectory());
		builder.append(", getType()=");
		builder.append(getType());
		builder.append(", getGXTFolderItemType()=");
		builder.append(getGXTFolderItemType());
		builder.append(", isVreFolder()=");
		builder.append(isVreFolder());
		builder.append(", toString()=");
		builder.append(super.toString());
		builder.append(", getProperties()=");
		builder.append(getProperties());
		builder.append(", getPropertyNames()=");
		builder.append(getPropertyNames());
		builder.append(", isAllowNestedValues()=");
		builder.append(isAllowNestedValues());
		builder.append(", getClass()=");
		builder.append(getClass());
		builder.append(", hashCode()=");
		builder.append(hashCode());
		builder.append("]");
		return builder.toString();
	}
}